Source: hcl2
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
Section: golang
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any,
               golang-github-agext-levenshtein-dev,
               golang-github-apparentlymart-go-dump-dev,
               golang-github-apparentlymart-go-textseg-dev,
               golang-github-bsm-go-vlq-dev,
               golang-github-davecgh-go-spew-dev,
               golang-github-dhowett-go-plist-dev,
               golang-github-google-go-cmp-dev,
               golang-github-go-test-deep-dev,
               golang-github-hashicorp-go-multierror-dev,
               golang-github-kr-pretty-dev,
               golang-github-kylelemons-godebug-dev,
               golang-github-mitchellh-go-wordwrap-dev,
               golang-github-sergi-go-diff-dev,
               golang-github-spf13-pflag-dev,
               golang-github-zclconf-go-cty-dev,
               golang-golang-x-crypto-dev,
               golang-gopkg-yaml.v2-dev,
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/hcl2
Vcs-Git: https://salsa.debian.org/go-team/packages/hcl2.git
Homepage: https://github.com/hashicorp/hcl2
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/hashicorp/hcl2

Package: hcl2
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: Former temporary home for experimental new version of HCL (program)
 HCL
 .
 HCL is a toolkit for creating structured configuration languages that
 are both human- and machine-friendly, for use with command-line tools.
 Although intended to be generally useful, it is primarily targeted
 towards devops tools, servers, etc.
 .
 HCL has both a *native syntax*, intended to be pleasant to read and
 write for humans, and a JSON-based variant that is easier for machines to
 generate and parse.
 .
 The HCL native syntax is inspired by libucl
 (https://github.com/vstakhov/libucl), nginx configuration
 (http://nginx.org/en/docs/beginners_guide.html#conf_structure), and
 others.
 .
 It includes an expression syntax that allows basic inline computation
 and, with support from the calling application, use of variables and
 functions for more dynamic configuration languages.
 .
 HCL provides a set of constructs that can be used by a calling
 application to construct a configuration language. The application
 defines which attribute names and nested block types are expected, and
 HCL parses the configuration file, verifies that it conforms to the
 expected structure, and returns high-level objects that the application
 can use for further processing.
 .
 Experimental HCL2
 .
 This repository was used for the initial development of version 2 of
 HCL, but is now archived because the work from this repository was
 incorporated back in to the main HCL repository
 (https://github.com/hashicorp/hcl).
 .
 This repository remains here for the moment for compatibility with
 existing callers that imported the experimental version. We strongly
 encourage switching to a stable release of HCL 2 as soon as possible.
 For more information on installing HCL 1 and/or HCL 2, please see the
 Version Selection guide (https://github.com/hashicorp/hcl/wiki/Version-
 Selection).
 .
 There will be no further development in this temporary experimental HCL
 2 repository.
 .
 Why?
 .
 Newcomers to HCL often ask: why not JSON, YAML, etc?
 .
 Whereas JSON and YAML are formats for serializing data structures, HCL
 is a syntax and API specifically designed for building structured
 configuration formats.
 .
 HCL attempts to strike a compromise between generic serialization
 formats such as JSON and configuration formats built around full
 programming languages such as Ruby. HCL syntax is designed to be easily
 read and written by humans, and allows *declarative* logic to permit its
 use in more complex applications.
 .
 HCL is intended as a base syntax for configuration formats built around
 key-value pairs and hierarchical blocks whose structure is well-defined by
 the calling application, and this definition of the configuration
 structure allows for better error messages and more convenient
 definition within the calling application.
 .
 It can't be denied that JSON is very convenient as a *lingua franca* for
 interoperability between different pieces of software. Because of this,
 HCL defines a common configuration model that can be parsed from either
 its native syntax or from a well-defined equivalent JSON structure. This
 allows configuration to be provided as a mixture of human-authored
 configuration files in the native syntax and machine-generated files in
 JSON.
 .
 Information Model and Syntax
 .
 HCL is built around two primary concepts: *attributes* and *blocks*. In
 native syntax, a configuration file for a hypothetical application might
 look something like this:
 .
   io_mode = "async"
 .
   service "http" "web_proxy" {
     listen_addr = "127.0.0.1:8080"
 .
     process "main" {
       command = ["/usr/local/bin/awesome-app", "server"]
     }
 .
     process "mgmt" {
       command = ["/usr/local/bin/awesome-app", "mgmt"]
     }
   }
 .
 The JSON equivalent of this configuration is the following:
 .
   {
     "io_mode": "async",
     "service": {
       "http": {
         "web_proxy": {
           "listen_addr": "127.0.0.1:8080",
           "process": {
             "main": {
               "command": ["/usr/local/bin/awesome-app", "server"]
             },
             "mgmt": {
               "command": ["/usr/local/bin/awesome-app", "mgmt"]
             },
           }
         }
       }
     }
   }
 .
 Regardless of which syntax is used, the API within the calling
 application is the same. It can either work directly with the low-level
 attributes and blocks, for more advanced use-cases, or it can use one of
 the *decoder* packages to declaratively extract into either Go structs
 or dynamic value structures.
 .
 Attribute values can be expressions as well as just literal values:
 .
   # Arithmetic with literals and application-provided variables
   sum = 1 + addend
 .
   # String interpolation and templates
   message = "Hello, ${name}!"
 .
   # Application-provided functions
   shouty_message = upper(message)
 .
 Although JSON syntax doesn't permit direct use of expressions, the
 interpolation syntax allows use of arbitrary expressions within JSON
 strings:
 .
   {
     "sum": "${1 + addend}",
     "message": "Hello, ${name}!",
     "shouty_message": "${upper(message)}"
   }
 .
 For more information, see the detailed specifications:
 .
  * Syntax-agnostic Information Model (/hcl/spec.md)
  * HCL Native Syntax (/hcl/hclsyntax/spec.md)
  * JSON Representation (/hcl/json/spec.md)
 .
 Acknowledgements
 .
 HCL was heavily inspired by libucl (https://github.com/vstakhov/libucl),
 by Vsevolod Stakhov (https://github.com/vstakhov).
 .
 HCL and HIL originate in HashiCorp Terraform (https://terraform.io/),
 with the original parsers for each written by Mitchell Hashimoto
 (https://github.com/mitchellh).
 .
 The original HCL parser was ported to pure Go (from yacc) by Fatih
 Arslan (https://github.com/fatih). The structure-related portions of the
 new native syntax parser build on that work.
 .
 The original HIL parser was ported to pure Go (from yacc) by Martin
 Atkins (https://github.com/apparentlymart). The expression-related
 portions of the new native syntax parser build on that work.
 .
 HCL2, which merged the original HCL and HIL languages into this single
 new language, builds on design and prototyping work by Martin Atkins
 (https://github.com/apparentlymart) in zcl
 (https://github.com/zclconf/go-zcl).

